package MovementStrategy;

public class MoveToBorder extends AbstractStrategy {
    @Override
    protected boolean IsTargetDestination()
    {
        var objParams = GetObjectParameters();
        if (objParams == null)
        {
            return false;
        }
        return objParams.RightBorder() <= FieldWidth &&
                objParams.RightBorder() + GetStep() >= FieldWidth &&
                objParams.DownBorder() <= FieldHeight &&
                objParams.DownBorder() + GetStep() >= FieldHeight;
    }

    // движение к цели
    @Override
    protected void MoveToTarget()
    {
        var objParams = GetObjectParameters();
        if (objParams == null)
        {
            return;
        }
        var diffX = FieldWidth;
        if (Math.abs(diffX) > GetStep())
        {
            if (diffX < 0)
            {
                MoveLeft();
            }
            else
            {
                MoveRight();
            }
        }

        var diffY = FieldHeight;
        if (Math.abs(diffY) > GetStep())
        {
            if (diffY < 0)
            {
                MoveUp();
            }
            else
            {
                MoveDown();
            }
        }
    }
}
